<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/PTree/Writer.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/PTree/Writer.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/PTree/Writer.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_PTree_Writer_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_PTree_Writer_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/PTree.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;sstream&gt;</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line14"></a><span class="lineno">14</span><span class="line">{</span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/PTree.html" title="namespace Synopsis::PTree">PTree</a></span>
<a id="line16"></a><span class="lineno">16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno">17</span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html" title="class Synopsis::PTree::Writer">Writer</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">Visitor</a></span>
<a id="line19"></a><span class="lineno">19</span><span class="line">{</span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">  <a href="" title="member function Synopsis::PTree::Writer::Writer(std::ostream&amp;)">Writer</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;os);</span>
<a id="line22"></a><span class="lineno">22</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">  <span class="keyword">unsigned long</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#write_lconst.Node_S_r" title="member function Synopsis::PTree::Writer::write(const Node*)">write</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *);</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#visit_lAtom_S_r" title="member function Synopsis::PTree::Writer::visit(Atom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">Atom</a> *);</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#visit_lList_S_r" title="member function Synopsis::PTree::Writer::visit(List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *);</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#visit_lBrace_S_r" title="member function Synopsis::PTree::Writer::visit(Brace*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Brace.html" title="class Synopsis::PTree::Brace">Brace</a> *);</span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#newline_l_r" title="member function Synopsis::PTree::Writer::newline()">newline</a>();</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/PTree/Writer.html#my_os" title="data member Synopsis::PTree::Writer::my_os">my_os</a>;</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  <a href="" title="typedef size_t">size_t</a>        <a href="../../../Scopes/Synopsis/PTree/Writer.html#my_indent" title="data member Synopsis::PTree::Writer::my_indent">my_indent</a>;</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  <span class="keyword">unsigned long</span> <a href="../../../Scopes/Synopsis/PTree/Writer.html#my_lines" title="data member Synopsis::PTree::Writer::my_lines">my_lines</a>;</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">};</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">inline <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/PTree.html#reify_lconst.Node_S_r" title="function Synopsis::PTree::reify(const Node*)">reify</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *p)</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">{</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <span class="keyword">if</span> (!<a href="" title="parameter p">p</a>) <span class="keyword">return</span> <span class="string">&quot;&quot;</span>;</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">  <span class="keyword">else</span> <span class="keyword">if</span> (<a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#is_atom_l_rconst" title="member function Synopsis::PTree::Node::is_atom()const">is_atom</a>()) <span class="keyword">return</span> std::string(<a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#position_l_rconst" title="member function Synopsis::PTree::Node::position()const">position</a>(), <a href="" title="parameter p">p</a>-&gt;<a href="../../../Scopes/Synopsis/PTree/Node.html#length_l_rconst" title="member function Synopsis::PTree::Node::length()const">length</a>());</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">  <a href="" title="typedef std::ostringstream">std::ostringstream</a> <a href="" title="local variable oss">oss</a>;</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Writer.html" title="class Synopsis::PTree::Writer">Writer</a> <a href="" title="local variable writer">writer</a>(oss);</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">  <a href="" title="local variable writer">writer</a>.<a href="../../../Scopes/Synopsis/PTree/Writer.html#write_lconst.Node_S_r" title="member function Synopsis::PTree::Writer::write(const Node*)">write</a>(<a href="" title="parameter p">p</a>);</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">  <span class="keyword">return</span> <a href="" title="local variable oss">oss</a>.str();</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">}</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">}</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">}</span>
<a id="line51"></a><span class="lineno">51</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
